#ifndef _expression
#define _expression


#include <stdio.h>
#include <iostream>
#include <vector>

#include <string>  
#include <map>  

#include <interval/interval.hpp>
#include "parser_types1.h"

#include "taylor.h"
#include "domain.h"
#include "mesh.h"

typedef filib::interval<double,filib::native_switched,filib::i_mode_extended> interval;

class expression
{
public:

    std::string chaine;
    expression();
    expression(string s);

    // Créer une expression dérivée par rapport à la variable variable.
    expression derive(string variable);

    // Evaluation intervalle.
    interval Evalue(domain p);
    interval forme_centre(domain x);

    // Evaluation intervalle.
    interval Evalue_en_coupant(domain p, int nb);
    interval forme_centre_en_coupant(domain p, int nb);
    
    expression forme_centre(void);  

    // fonction qui calcule les coefficients de taylor à l'ordre ordre (méthode forward)
    vector <double> taylor_f(domain p, int ordre);
    vector <interval> taylor_ode(taylor p, int ordre);

    // Remplit chaine à partir de l'arbre
    void ArbreToChaine();
    // Exporter l'expression dans d'autre langage.
    void ToLatex(char *);
    void ToDot(char *);

    bool simplify(); //fonction qui fait une seule simplification, renvoie vraie si une simplification a eu lieu. 
    void Simplify(); //fonction qui essaie de simplifier autant que possible.
    std::set <std::string> variables; //liste des variables d'une expression
    expression substitue_partial(string name); 
    expression substitute(string new_variable, string old); 
    expression substitute(double value, string variable); 

    // opération algébrique sur les expressions
    expression operator+(expression v);
    expression operator*(expression v);
    expression operator-(expression v);
    expression pow(int);

private :
    std::vector <Node> arbre_node;
    int creation_arbre_de_node();
    void variables_eq();

    std::map  <std::string, expression> derives;


    
};

#endif
