#ifndef _hermite
#define _hermite

#include "domain.h"
#include "expression.h"
#include <fstream>
#include <vector>
#include <string>


// La fonction qui est créée est la suivante
// [ (x - x_0)^2 * ( -2 * x - x_0 + 3 x_1) ] / (x_1 - x_0)^3

// Attention, cette classe de base ne travaille qu'avec des intervalles
// autrement dit, les noms de variables indépendantes n'apparaissent pas du tout
class hermite
{
 public :
  hermite() {};
  hermite(interval support0);
  interval evalue(interval x);
  interval evalue_prime(interval x);
  
 private :
  interval support;
  double support_g;
  double milieu;
  double support_d;
  
  expression f;
  expression f_prime;
};





class fonction_test
{
 public :
  fonction_test(domain support0);
  interval evalue(domain entree);

  interval evalue_d_dt(domain entree);
  interval evalue_d_dx(domain entree);

  

  
  void to_gnuplot(char * filename);
  
  //  interval evalue(domain x);
 private :
  domain support;
  hermite * varphi_t;
  hermite * varphi_x;
};











#endif


