#include <iostream>
#include <string>
#include <stdlib.h>
#include <sstream>
#include <fstream>


#include "expression.h"
#include "mesh.h"
#include "vinter.h"

#include "hermite.h"

typedef filib::interval<double,filib::native_switched,filib::i_mode_extended> interval;


int main(int argc, char *argv[])
{

  Map champ ;
  champ.set_component("x",expression("1+x*(1-u)"));
  //  champ.set_component("x",expression("2-u"));

  expression _h("x + u");
  //  expression _h("x");
  
  expression _H("0");

  domain _K;
  _K["x"]  = interval(0,1);

  domain _T;
  _T["t"]  = interval(0,2);
  
  // la borne sup doit être supérieure à exp(2)-1
  domain _X;
  _X["x"]  = interval(0,7);

  domain _U;
  //  _U["u"]  = interval(0,1);
  _U["u"]  = interval(0,3);
  

  // un champ de vecteurs commandé
  // une domain K
  // un domain X
  // un domain U
  // un domain T
  // une condition initiale x_0

 
  int nb = 250; //découpage de X \times U 

  domain x_0;
  //  x_0["x"] = interval(2.82,2.82);
  x_0["x"] = interval(0,0);

  vinter mon_vinter(champ,  _h,  _H,  _K  ,  _T,  _X ,  _U , x_0); 
  
  mon_vinter.construit_mesh(nb);
  mon_vinter.construit_cout();

  mon_vinter.contraintes_temporelles();

  mon_vinter.contrainte("1", "0");

  mon_vinter.construit_contraintes(1,6);
  mon_vinter.construit_contraintes_hermites(1,30);
  mon_vinter.construit_contraintes_hermites(6,25);

  mon_vinter.construit_contraintes_hermites(11,20);

  
  /* mon_vinter.construit_contraintes_hermites(6,50);
  */
  
  /* mon_vinter.construit_contraintes_hermites(1,30);
  mon_vinter.construit_contraintes_hermites(12,20);
  mon_vinter.construit_contraintes_hermites(30,20);
  */
  
  mon_vinter.write();
  
  //  mon_vinter.construit_contraintes_hermites(2,20);
  double result = mon_vinter.solve("turnpike.pov");
  //  mon_vinter.show_result();

  //  mon_vinter.solution_to_gnuplot("results.dat");
  
  // test d'Hermite
  /*  hermite phi(interval(2.6,3.8));
  cout << endl;
  
  domain d_test;
  d_test["x"] = interval(-0.1,0.3);
  d_test["t"] = interval(-0.5,0.5);
  
  fonction_test varphi (d_test);

  varphi.to_gnuplot((char *)"sortiegp.gp");
  */
  
  return 0;
}






  // cout << result;

      //      fichier << nb <<  ";" << mon_vinter.cardinal_variable() << ";" << mon_vinter.cardinal_contraints() << ", obj :" << result << endl ;



  // result =   mon_vinter.test_vrai_solution();

  /*
  expression toto("2*x*y^3-x*y^2");
  cout << toto.derive("y").chaine << endl;

  domain test;
  test["x"] = interval(1,2);
  test["y"] = interval(1,2);

  domain test2;
  test2["x"] = interval(1,1.5);
  test2["y"] = interval(1,1.5);

  domain test3;
  test3["x"] = interval(1.5,2);
  test3["y"] = interval(1.5,2);
  
  cout << toto.Evalue(test) << endl;
  cout << toto.forme_centre(test) << endl;

  cout << toto.Evalue_en_coupant(test, 10) << endl;
  cout << toto.forme_centre_en_coupant(test, 10) << endl;
  */
  
  //  cout << result << endl;



  /*  domain d_test;
  d_test["x"] = interval(-2.0,-1.0);
  d_test["t"] = interval(0.2,0.5);

  mon_vinter.contrainte_hermite(d_test);*/
