#include "map.h"

Map::Map(vector < expression >  g)
{
 
  string a;
  for (int j = 0; j< g.size(); j++)
    { 
      ostringstream buffer;
      buffer << j;
      string a = "y" + buffer.str();
      dependent_variable.insert(a);
      component[a] = g[j];
      
      independent_variable.insert(g[j].variables.begin(),g[j].variables.end()); 
      
      /*      cout << a << endl;
      cout << g[j].chaine << endl;
      */
    } 

  /*  cout << "cardinal of independent variables : "<< independent_variable.size() << endl;
      cout << "cardinal of dependent variables : "<< dependent_variable.size() << endl;*/
};


Map Map::derive( Map vector_field  )
{
  Map result;
  result = (*this); // permet de récupérer les même variables et 
  std::set<string>::const_iterator dep,indep;
  
  for( dep = dependent_variable.begin() ; dep!= dependent_variable.end() ;++dep)
    {
      result.component[*dep] = expression("0");      
      for( indep = independent_variable.begin() ; indep!= independent_variable.end() ;++indep)
	{
	  result.component[*dep] = result.component[*dep] + vector_field.get_component(*indep)*(*this).component[*dep].derive(*indep);
	}
    }
  return result;
}



Map Map::derive( Map vector_field , int times  )
{
  Map result;
  result = (*this); // permet de récupérer les même variables et 
  std::set<string>::const_iterator dep,indep;
  
  for (int l=1 ; l <=times ; l++) 
    result = result.derive(vector_field);

  return result;
}



taylor Map::derive( vector_field xi , int ordre , domain x )
{
  std::set<string>::const_iterator dep ;
  taylor result;
  taylor curve_t = xi.Taylor(x,ordre);
  
  for( dep = dependent_variable.begin() ; dep!= dependent_variable.end() ;++dep) 
    result[*dep] = component[*dep].taylor_ode(curve_t,ordre);
  
  
  return result;
}







void Map::add(expression e)
{
  int j = dependent_variable.size();
  ostringstream buffer; buffer << j;
  string a = "y" + buffer.str();
  dependent_variable.insert(a);
  component[a] = e;
  independent_variable.insert(e.variables.begin(),e.variables.end()); 
}


Map::Map(expression e)
{
  ostringstream buffer;
  buffer << dependent_variable.size();;
  string a = "y" + buffer.str();
  dependent_variable.insert(a);
  component[a] = e;
  independent_variable.insert(e.variables.begin(),e.variables.end()); 
};


domain Map::evalue(domain P)
{
  domain result;
  std::set<string>::const_iterator dep ;
  
  for( dep = dependent_variable.begin() ; dep!= dependent_variable.end() ;++dep) 
      result[*dep] = component[*dep].Evalue(P);
  return result;
};


expression Map::get_component(string chaine)
{
  return component[chaine];
}


void Map::set_component(string ch, expression e)
{
  expression m = component[ch];
  std::set<string>::const_iterator dep;
  for( dep = m.variables.begin() ; dep!= m.variables.end() ;++dep) 
    {
      independent_variable.erase(*dep);
    }
  dependent_variable.insert(ch);
  component[ch] = e;
  independent_variable.insert(e.variables.begin(),e.variables.end()); 
}


expression_matrix Map::differentielle()
{
  expression_matrix result;
  std::set<string>::const_iterator dep,indep;

  for( dep = dependent_variable.begin() ; dep!= dependent_variable.end() ;++dep)
    for( indep = independent_variable.begin() ; indep!= independent_variable.end() ;++indep)
      result.coefficient[*dep][*indep] = component[*dep].derive(*indep);

  for( dep = dependent_variable.begin() ; dep!= dependent_variable.end() ;++dep)
    result.dependent_variable.push_back(*dep);

  for( indep = independent_variable.begin() ; indep!= independent_variable.end() ;++indep)
    result.independent_variable.push_back(*indep);

  return result;
}


void  Map::out()
{
  std::set<string>::const_iterator dep,indep;
  cout << "cardinal of independent variables : "<< independent_variable.size() << endl;
  for( indep = independent_variable.begin() ; indep!= independent_variable.end() ;++indep) 
    {
      cout << *indep << endl ;
    }

  cout << "cardinal of dependent variables : "<< dependent_variable.size() << endl; 
  for( dep = dependent_variable.begin() ; dep!= dependent_variable.end() ;++dep) 
    {
      cout << *dep << endl ;
    }

  for( dep = dependent_variable.begin() ; dep!= dependent_variable.end() ;++dep) 
    {
      cout << *dep << " : " << component[*dep].chaine << endl;
    }


}
