#ifndef _Map
#define _Map

#include <interval/interval.hpp>

#include "expression.h"
#include "vector_field.h"

#include "domain.h"
#include "matrix.h"


using namespace std; 
typedef filib::interval<double,filib::native_switched,filib::i_mode_extended> interval;

class Map
{

 public :
  map <string, expression> component; 

  Map() {};

  Map( vector < expression > g  );

  Map( expression );
  domain evalue( domain );

  expression_matrix differentielle();

  set <string> dependent_variable;
  set <string> independent_variable;
 
  void add(expression);
  void out();
  
  expression get_component(string );
  void set_component(string ch, expression e);
  
  Map derive( Map vector_field  );
  Map derive( Map vector_field, int times  );
  
  taylor derive( vector_field xi , int times , domain x );


};

#endif
 
