#include "mesh.h"
#include <math.h>


// pour la gestion du bord
mesh::mesh( domain _initial)
{
  initial = _initial;
  (*this).push_back(_initial);

  for (domain::const_iterator i = _initial.begin(); i!=_initial.end();++i)
    {
      domain _inf = _initial;
      domain _sup = _initial;
      string axe = i->first;
      _inf[i->first] = interval(i->second.inf(),i->second.inf());
      _sup[i->first] = interval(i->second.sup(),i->second.sup());
      (*this).initial_boundary.push_back(_inf);
      (*this).initial_boundary.push_back(_sup);
    }
}

// which_one (ATTENTION NE SEMBLE MARCHER QUE EN DIMENSION 2)
int mesh::which_one( domain point)
{
  double a,b;
  int result=0;
  int dimension = initial.dimension()-1 ;
  vector < map < string , int  >  > les_cases;
  for (domain::const_iterator i = initial.begin(); i!=initial.end();++i)
    {
      string axe = i->first;      
      a = initial[axe].inf();
      b = initial[axe].sup();
      double result2 = nombre*(point[axe].inf() - a ) / (b-a);      
      //      result = floor(result2) + result*(pow(nombre,dimension));

      map < string , int > la_case;
      la_case["axe"] = floor(result2);
      result = result + floor(result2)*(pow(nombre,dimension));
      dimension--;
    }

  
  
  return result;
}

// which_one
domain  mesh::which( domain point)
{
  domain result = point;
  for (mesh::const_iterator i = begin(); i!=end();++i)
    {
      domain p = *i;
      if (point.subset(p))
	{
	  result = p;
	}
      
    }
  return result;
}



int mesh::compteur(int dim)
{
  int result = 0;
    for (mesh::const_iterator i = begin(); i!=end();++i)
      {
	domain temp = *i;
	if (temp.topological_dimension() == dim)
	  {
	    result = result + 1;
	  };
      }   
    return result;
}

mesh::mesh( domain _initial , int nb, bool b)
{
  mesh result;
  mesh temp(_initial);
  for (domain::const_iterator i = _initial.begin(); i!=_initial.end();++i)
    {
      string axe = i->first;
      // attention, découpage spéciale avec l'axe temporelle
      if (axe=="t")
	{	
	  mesh temp2 = temp.cut(axe,nb);
	  temp = temp2;
	}
      else
	{
	  mesh temp2 = temp.cut_with_intersection(axe,nb);
	  temp = temp2;
	}
    }
  result = temp;
  result.nombre = nb;
  (*this) = result;
}


mesh::mesh( domain _initial , int nb)
{
  mesh result;
  mesh temp(_initial);
  for (domain::const_iterator i = _initial.begin(); i!=_initial.end();++i)
    {
      string axe = i->first;
      mesh temp2 = temp.cut(axe,nb);
      temp = temp2;
    }
  result = temp;
  result.nombre = nb;
  (*this) = result;
}


mesh mesh::cut(string axe, int nb)
{
  mesh result;
  result.initial = (*this).initial;
  result.nombre = (*this).nombre;
  result.initial_boundary =  (*this).initial_boundary;
  int taille = size();
  for (int i = 0; i < taille; i++)
    {
      domain to_be_cut = (*this)[i];
      double min = to_be_cut[axe].inf();
      double max = to_be_cut[axe].sup();
      double largeur = max - min ;
      if (largeur != 0)
	{
	  double delta = largeur/ (double)nb;
	  for (int j = 0 ; j<nb ; j++)
	    {
	      domain x = to_be_cut;
	      interval d(min+delta*j , min+delta*(j+1) );
	      x[axe] = d;
	      result.push_back(x);
	      // result.boundary.push_back(j==0 || j==nb-1 || (*this).boundary[i]);
	    }
	}
	  else
	    {
	      result.push_back(to_be_cut);	      
	    }
    }
  return result;
}


mesh mesh::cut_with_intersection(string axe, int nb)
{
  mesh result;
  result.initial = (*this).initial;
  result.nombre = (*this).nombre;
  result.initial_boundary =  (*this).initial_boundary;
  int taille = size();
  for (int i = 0; i < taille; i++)
    {
      domain to_be_cut = (*this)[i];
      double min = to_be_cut[axe].inf();
      double max = to_be_cut[axe].sup();
      double largeur = max - min ;
      if (largeur != 0)
	{
	  double delta = largeur/ (double)nb;
	  for (int j = 0 ; j<nb ; j++)
	    {
	      domain x = to_be_cut;
	      interval d(min+delta*j , min+delta*(j+1) );
	      x[axe] = d;
	      result.push_back(x);

	      if (j != nb - 1)
		{
		  x = to_be_cut;
		  interval d2(min+delta*j , min+delta*(j) );
		  x[axe] = d2;
		  result.push_back(x);
		}
	    }
	}
	  else
	    {
	      result.push_back(to_be_cut);	      
	    }
    }
  return result;
}
    

void mesh::out()
{
  for (mesh::const_iterator i = begin(); i!=end();++i)
    {
      domain temp = *i;
      temp.out();
    }
}

void mesh::myinsert(mesh m2)
{
  (*this).insert( (*this).end(), m2.begin(), m2.end() );
}
    

// construit le bord du pavage
mesh mesh::boundary()
{
  mesh result;
  for (int i = 0; i<initial_boundary.size();i++)
    {
      result.myinsert(mesh(initial_boundary[i],nombre));
    }
  return result;
}


bool mesh::voisin(int i, int j)
{
  return ! ((*this)[i].disjoint((*this)[j]));
}


// calcule l'enveloppe interval d'une liste de pavés
domain mesh::wrapping(vector < int > vect)
{
  domain result = (*this)[vect[0]];
  for (int i=1; i < vect.size(); i++ )
    {
      result = result.hull((*this)[vect[i]]);
    }
  return result;
};





