// PoVRay Version 3.1 / 3.5 scenery include file
// save as "axis_xyz.inc"
// created by Lohmueller, 2002,2003 
//--------------------------------------
#macro Axis( AxisLen, RedTexture,WhiteTexture) 
union{
    cylinder {<0,-AxisLen,0>,<0,AxisLen,0>,0.02
              texture{checker 
                      texture{RedTexture} 
                      texture{WhiteTexture}
                      translate<0.1,0,0.1>
                     }
             }// end of cylinder
    cone{<0,AxisLen,0>,0.1,<0,AxisLen+0.35,0>,0
         texture{RedTexture}}
     } // end of union "AchseY"                  
#end // of macro Achse (AchsenLen)
//--------------------------------------
#macro AxisXYZ( AxisLenX, AxisLenY, AxisLenZ, TexRed, TexWhite)
//--------------------- 3 Achsen zeichnen ----------------------------------------
union{
object{Axis(AxisLenX, TexRed, TexWhite)   rotate< 0,0,-90>}   // x-Achse
object{Axis(AxisLenY, TexRed, TexWhite)   rotate< 0,0,  0>}   // y-Achse
object{Axis(AxisLenZ, TexRed, TexWhite)   rotate<90,0,  0>}   // z-Achse
//--------------------- Achsenbezeichnungen --------------------------------------
} // end of union
//--------------------------------------------------------------------------------
#end// of macro 
//--------------------------------------------------------- end of "AxisXYZ.inc"



#macro Superbox( x0,  // column height
                 y0,  // base radius
                 z0,  // border radius
                 x1,  // top scale
                 y1,  // top scale
                 z1,  // 
                 transparence,
                 diam
               ) //---------------------
union{
  box
  {
    < x0, y0, z0> < x1, y1, z1>
    pigment {color rgbf < .4, .4, 1, transparence>}
  }

  cylinder
  {
    < x0, y0, z0>, < x1, y0, z0>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y1, z0>, < x1, y1, z0>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y0, z0>, < x0, y1, z0>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }

  cylinder
  {
    < x1, y0, z0>, < x1, y1, z0>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y0, z1>, < x1, y0, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y1, z1>, < x1, y1, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y0, z1>, < x0, y1, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }

  cylinder
  {
    < x1, y0, z1>, < x1, y1, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }

    cylinder
  {
    < x0, y0, z0>, < x0, y0, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y1, z0>, < x0, y1, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x1, y1, z0>, < x1, y1, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }

  cylinder
  {
    < x1, y0, z0>, < x1, y0, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
 
 }// end Column
#end 
//------------------- end of macro 




#macro Superboxvide( x0,  // column height
                 y0,  // base radius
                 z0,  // border radius
                 x1,  // top scale
                 y1,  // top scale
                 z1,  // 
                 transparence,
                 diam
               ) //---------------------
union{

  cylinder
  {
    < x0, y0, z0>, < x1, y0, z0>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y1, z0>, < x1, y1, z0>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y0, z0>, < x0, y1, z0>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }

  cylinder
  {
    < x1, y0, z0>, < x1, y1, z0>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y0, z1>, < x1, y0, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y1, z1>, < x1, y1, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y0, z1>, < x0, y1, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }

  cylinder
  {
    < x1, y0, z1>, < x1, y1, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }

    cylinder
  {
    < x0, y0, z0>, < x0, y0, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x0, y1, z0>, < x0, y1, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
  
  cylinder
  {
    < x1, y1, z0>, < x1, y1, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }

  cylinder
  {
    < x1, y0, z0>, < x1, y0, z1>, diam
    pigment {color rgbf < 0, 0, 0, 0>}
  }
 
 }// end Column
#end 
//------------------- end of macro 

