#version 3.6;
global_settings { assumed_gamma 1.0 }

#include "colors.inc"
#include "textures.inc"


// camera --------------------------------------------------------------
#declare Cam1 = camera {ultra_wide_angle angle  20
                        location  < 30.0 , 50.0 ,-60.0> 
                        look_at   < 1.0 , 0.0 ,  0.0>}
#declare Cam2 = camera {ultra_wide_angle angle  65
                        location  < 0.0 , 2.0 ,-15.0>
                        look_at   < 2.0 , 2.0 , 0.0>}
camera{Cam1}


light_source{<1800,2500,-2500> color White}
#declare Orange_Yellow = color rgb<1,0.77,0>;

sphere{<0,0,0>,1 hollow
       texture{pigment{gradient <0,1,0>
                       color_map{[0.0 color Orange_Yellow]
                                 [0.5 color White]
                                 [1.0 color Orange_Yellow]}
                       quick_color White
                       scale 2 translate<0,-1,0> }
               finish {ambient 1 diffuse 0}
              }
       scale 10000}


//------------------------------------------------------------------------
#include "axis_xyz.inc" // contient aussi superbox
#declare RED   = texture{pigment{color rgb<0.8,0,0.45> }
                         finish {ambient 0.1 diffuse 0.9 phong 1}}
#declare BLACK = texture{pigment{color rgb<1,1,1> }
                         finish {ambient 0.5 diffuse 0.5 phong 1}}

object{ AxisXYZ (12, 5, 10,  RED, RED)}


text {
ttf "timrom.ttf" "t" 0.05, 0
pigment { Red }
translate <11, 0, 0>
}


text {
ttf "timrom.ttf" "x" 0.05, 0
pigment { Red }
rotate <0,0,0>
translate <0, 4.5, 0>
}


text {
ttf "timrom.ttf" "u" 0.05, 0
pigment { Red }
rotate <0,-90,0>
translate <0, 0, 10>
}








object{ Superboxvide(0,0,0,10,10,4,1,0.01 ) }
object{ Superbox(0,0,3.6,1,1,4,0.975566,0.01 ) }
object{ Superbox(0,1,3.6,1,2,4,0.97863,0.01 ) }
object{ Superbox(0,3,3.6,1,4,4,0.966767,0.01 ) }
object{ Superbox(0,4,3.6,1,5,4,0.979036,0.01 ) }
object{ Superbox(1,0,3.6,2,1,4,0.935923,0.01 ) }
object{ Superbox(1,3,3.6,2,4,4,0.964077,0.01 ) }
object{ Superbox(2,1,3.6,3,2,4,0.991663,0.01 ) }
object{ Superbox(2,2,3.6,3,3,4,0.938723,0.01 ) }
object{ Superbox(2,3,3.6,3,4,4,0.969614,0.01 ) }
object{ Superbox(3,1,3.6,4,2,4,0.9,0.01 ) }
object{ Superbox(4,0,3.6,5,1,4,0.942788,0.01 ) }
object{ Superbox(4,6,3.6,5,7,4,0.957212,0.01 ) }
object{ Superbox(5,4,3.6,6,5,4,0.905333,0.01 ) }
object{ Superbox(5,5,3.6,6,6,4,0.994667,0.01 ) }
object{ Superbox(6,5,3.6,7,6,4,0.95188,0.01 ) }
object{ Superbox(6,7,3.6,7,8,4,0.94812,0.01 ) }
object{ Superbox(7,6,3.6,8,7,4,0.92837,0.01 ) }
object{ Superbox(7,7,3.6,8,8,4,0.97163,0.01 ) }
object{ Superbox(8,5,3.6,9,6,4,0.918689,0.01 ) }
object{ Superbox(8,6,3.6,9,7,4,0.981311,0.01 ) }
object{ Superbox(9,1,3.6,10,2,4,0.98877,0.01 ) }
object{ Superbox(9,7,3.6,10,8,4,0.958369,0.01 ) }
object{ Superbox(9,8,3.6,10,9,4,0.952862,0.01 ) }
// ici nu ---------
object{ Superbox(9.99,9,-0.01,10.1,10,0.01,-2.22045e-16,0.02 ) }
